> For the complete documentation index, see [llms.txt](https://docs.decentraland.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.decentraland.org/creator/content-creator-ko/marketplace/estates-marketplace-integrations.md).

# 에스테이트 마켓플레이스 통합

마켓플레이스에 Decentraland의 에스테이트를 통합하고 싶다면 고려해야 할 중요한 사항

## 마켓플레이스에 Decentraland Estate 통합하기

Decentraland Estate는 ERC721을 준수하는 NFT이며 Ethereum 메인넷에서 작동합니다. 따라서 여러 타사 마켓플레이스에서 거래할 수 있습니다. 거래를 지원하려면 이 마켓플레이스가 사용자의 거래를 안전하게 보호하기 위한 몇 가지 규칙을 따라야 합니다.

아시다시피 각 [Estate](https://docs.decentraland.org/decentraland/faq/#what-is-an-estate) 는 여러 [LAND](https://docs.decentraland.org/decentraland/faq/#what-is-land) 를 묶은 그룹이며, 이 그룹에는 *바이트* 해시가 연결되어 있습니다. 이 해시를 *`fingerprint`*&#xB77C;고 합니다. Estate에 LAND를 추가하거나 제거하면 Estate가 변경될 때마다 *`fingerprint`* 도 함께 변경됩니다.

마켓플레이스, 특히 에스크로 시스템이 없는 마켓플레이스에서는 누군가 Estate를 판매 목록에 올리거나 오퍼를 제출할 때 Estate의 *`fingerprint`* 를 기록해 두는 것을 강력히 권장합니다. 이렇게 하면 주문이나 오퍼가 성공적으로 실행될 때 현재 소유자가 주문 실행을 선행하기 위해 Estate를 변경하는 일을 막을 수 있습니다.

비어 있는 Estate는 판매 목록에 올리지 않는 것이 좋습니다. Estate 스마트 계약에는 Estate에 포함된 LAND의 개수를 반환하는 `getEstateSize` 메서드가 있습니다. 결과가 `0`인 경우 해당 Estate를 판매 목록에 올리지 않는 것이 좋습니다. 그래도 등록하려면 다음과 같은 이미지가 표시됩니다.

![](https://3980763956-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FoPnXBby9S6MrsW83Y9qZ%2Fuploads%2Fgit-blob-e98d87470ca9ff53ce25f1950c9b9649357e8511%2Fdissolved_estate.webp?alt=media)

## 예제

### Estate fingerprint를 사용하지 않는 경우

* Bob은 (1,1)과 (1,2) LAND가 포함된 Estate1을 소유하고 있습니다. Estate1 fingerprint: hash1
* Bob은 (1,3) LAND를 Estate1에 추가합니다. Estate1에는 다음 LAND가 포함됩니다. (1,1), (1,2), (1,3). Estate1 fingerprint: hash2 (fingerprint 변경됨)
* Bob은 (1,1) LAND를 Estate1에서 제거합니다. Estate1에는 (1,2)와 (1,3) LAND가 포함됩니다. Estate1 fingerprint: hash3 (fingerprint 변경됨)
* Bob은 Estate1을 판매 목록에 올립니다. Ethereum 메인넷에서 Estate 스마트 계약 주소, Estate ID, 가격, 만료일을 포함한 목록이 온체인에 생성됩니다.
* Alice는 지불할 가격과 Estate ID를 지정해 Estate를 구매하는 트랜잭션을 전송합니다.
* Bob은 누군가 Estate1을 구매하려 한다는 사실을 알아차리고, Alice보다 높은 가스 수수료를 설정한 트랜잭션을 보내 Estate1에서 (1,2) 및 (1,3) LAND를 제거합니다.
* Bob의 트랜잭션이 먼저 채굴됩니다. Estate1에는 LAND가 0개 있습니다. Estate1 fingerprint: hash4 (fingerprint 변경됨)
* Alice의 트랜잭션은 나중에 채굴됩니다. Alice는 LAND가 하나도 없는 Estate1을 구매했습니다. 즉, Bob이 Alice보다 먼저 거래를 실행해 Alice를 속이고 자산을 가로챈 것입니다.

### Estate fingerprint를 사용하는 경우

* Bob은 (1,1)과 (1,2) LAND가 포함된 Estate1을 소유하고 있습니다. Estate1 fingerprint: hash1
* Bob은 (1,3) LAND를 Estate1에 추가합니다. Estate1에는 다음 LAND가 포함됩니다. (1,1), (1,2), (1,3). Estate1 fingerprint: hash2 (fingerprint 변경됨)
* Bob은 (1,1) LAND를 Estate1에서 제거합니다. Estate1에는 (1,2)와 (1,3) LAND가 포함됩니다. Estate1 fingerprint: hash3 (fingerprint 변경됨)
* Bob은 Estate1을 판매 목록에 올립니다. Ethereum 메인넷에서 Estate 스마트 계약 주소, Estate ID, 가격, 만료일을 포함한 목록이 온체인에 생성됩니다.
* Alice는 지불할 가격과 Estate ID를 지정해 Estate를 구매하는 트랜잭션을 전송하고, **자신이 확인한 fingerprint(hash3)도 함께 보냅니다.**.
* Bob은 누군가 Estate1을 구매하려 한다는 사실을 알아차리고, Alice보다 높은 가스 수수료를 설정한 트랜잭션을 보내 Estate1에서 (1,2) 및 (1,3) LAND를 제거합니다.
* Bob의 트랜잭션이 먼저 채굴됩니다. Estate1에는 LAND가 0개 있습니다. Estate1 fingerprint: hash4 (fingerprint 변경됨)
* Alice가 보낸 매개변수의 fingerprint가 현재 Estate1의 fingerprint와 일치하지 않으므로 스마트 계약이 Alice의 트랜잭션을 되돌립니다(hash3 != hash4). 이 검사를 통해 Alice가 원하지 않는 Estate를 구매하는 일을 막았습니다.

## Estate 스마트 계약 fingerprint 인터페이스

Estate 스마트 계약은 [fingerprint 인터페이스](https://github.com/decentraland/land/blob/master/contracts/estate/EstateStorage.sol#L19)를 준수합니다. Estate를 판매 목록에 올리거나 오퍼를 받으면 *`getFingerprintV2(uint256 estateId)`* 를 호출해 fingerprint를 기록하고 반환된 값을 저장하세요. 주문이나 오퍼가 실행 시점에도 유효한지 확인하려면 *`verifyFingerprint(uint256 estateId, bytes fingerprint)`* 를 저장된 값과 함께 호출하세요.

항상 *`getFingerprintV2`*&#xAC00; 반환하는 값을 저장하세요. 이전 *`getFingerprint`* 메서드는 하위 호환성을 위해서만 유지되고 있으며 단계적으로 폐지될 예정입니다. 2026년 11월 26일부터 *`verifyFingerprint`* 는 이 메서드가 생성한 값을 더 이상 허용하지 않습니다. 새로 통합하는 경우에는 *`getFingerprintV2`*.

실제 운영 환경에서 작동하는 예제는 [여기에서 확인할 수 있습니다.](https://github.com/decentraland/marketplace-contracts/blob/master/contracts/marketplace/MarketplaceV2.sol#L382).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.decentraland.org/creator/content-creator-ko/marketplace/estates-marketplace-integrations.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
